﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Ball : MonoBehaviour
{
    public BallGFXParent Graphics;
    Rigidbody2D RB;
    public bool isDead = false;

    void Awake()
    {
        RB = GetComponent<Rigidbody2D>();
    }

    // Start is called before the first frame update
    void Start()
    {
        
    }

    // Update is called once per frame
    void FixedUpdate()
    {
        if (isDead)
        {
            RB.angularVelocity = 0;
            return;
        }

    }

    private void Update()
    {
        Graphics.SetTarget(RB.position);
    }

    public void Fire(float force, Rigidbody2D rb)
    {
        RB.velocity = rb.velocity;
        RB.AddForce(Vector2.up * (5000f + 1000 * force));
        RB.AddTorque(200f);
        // RB.isKinematic = false;

        Graphics.Fire();
    }

    internal void Reset(Vector2 position)
    {
        RB.velocity = Vector2.zero;
        RB.angularVelocity = 0;
        RB.position = position + Vector2.up * 0.5f;
        Graphics.StopRotation();
        // RB.isKinematic = true;
    }

    private void OnCollisionEnter2D(Collision2D collision)
    {
        if (isDead)
            return;

        if (collision.gameObject.TryGetComponent<Floor>(out _))
        {
            RB.velocity = Vector2.zero;
            RB.angularVelocity = 0;
            isDead = true;
            Graphics.TriggerDeath(RB.position);
            Audio.inst.PlayOhNo();
            UI.inst.SetInstructions(true);
        }
    }


    public void Restart()
    {
        RB.MovePosition(Vector3.zero);
        Reset(Vector2.zero);
        Graphics.Reset();
        isDead = false;
        RB.MovePosition(Vector3.zero);
        Reset(Vector2.zero);
    }

    internal void AddSideThrust()
    {
        if (RB.velocity.y > 0)
            RB.AddForce(Vector2.left * UnityEngine.Random.Range(-10f, 10f) * 200);
    }
}
