﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.VFX;

public class BallGFX : MonoBehaviour
{
    public TargetJoint2D targetJoint;
    public Rigidbody2D body;
    public Rigidbody2D[] limbs;

    // Update is called once per frame
    void FixedUpdate()
    {
    }

    public void Fire()
    {
        body.AddTorque(UnityEngine.Random.Range(-5, 5) * 100);
        
        foreach (var l in limbs)
        {
            l.AddTorque(UnityEngine.Random.Range(-5, 5) * 100);
        }

    }

    internal void SetTarget(Vector2 position)
    {
        targetJoint.target = position;
    }

    public void StopRotation()
    {
        body.angularVelocity = 0f;
    }

    public void TriggerDeath(Vector3 deathPos)
    {
        targetJoint.enabled = false;
        var hjs = GetComponentsInChildren<HingeJoint2D>();

        foreach (var hj in hjs)
        {
            hj.enabled = false;
        }
    }

    public void Reset()
    {
        targetJoint.enabled = true;
        body.transform.position = Vector3.zero;
        SetTarget(Vector2.zero);
        var hjs = GetComponentsInChildren<HingeJoint2D>();

        foreach (var hj in hjs)
        {
            hj.enabled = true;

        }
        StopRotation();
    }
}
