﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

[System.Serializable]
public class ObjectPoolItem
{
    public GameObject ObjectToPool;
    public int AmountToPool;
    public bool ShouldExpand;
}

public class ObjectPool : MonoBehaviour
{
    public static ObjectPool Inst;
    public List<ObjectPoolItem> ItemsToPool;
    public List<GameObject> PooledObjects;

    // Use this for initialization
    void Start()
    {
        Inst = this;

        PooledObjects = new List<GameObject>();
        foreach (ObjectPoolItem item in ItemsToPool)
        {
            for (int i = 0; i < item.AmountToPool; i++)
            {
                GameObject obj = (GameObject)Instantiate(item.ObjectToPool);
                obj.name = item.ObjectToPool.name;
                obj.transform.parent = transform;
                obj.SetActive(false);
                PooledObjects.Add(obj);
            }
        }
    }

    public GameObject GetPooledObject(string tag)
    {
        for (int i = 0; i < PooledObjects.Count; i++)
        {
            if (!PooledObjects[i].activeInHierarchy && PooledObjects[i].name == tag)
            {
                return PooledObjects[i];
            }
        }
        foreach (ObjectPoolItem item in ItemsToPool)
        {
            if (item.ObjectToPool.tag == tag)
            {
                if (item.ShouldExpand)
                {
                    GameObject obj = (GameObject)Instantiate(item.ObjectToPool);
                    obj.SetActive(false);
                    PooledObjects.Add(obj);
                    return obj;
                }
            }
        }
        return null;
    }

    // Update is called once per frame
    void Update()
    {

    }
}
