﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.VFX;

public class Target : MonoBehaviour
{
    public SpriteRenderer Burger;
    public SpriteRenderer Pacifier;
    public SpriteRenderer Study;
    public SpriteRenderer Money;
    public SpriteRenderer Coin;
    public SpriteRenderer Apple;
    public SpriteRenderer Rocket;

    SpriteRenderer Sprite;

    bool isTouched = false;

    // Start is called before the first frame update
    void Start()
    {
    }

    // Update is called once per frame
    void Update()
    {  
    }


    public void SetGraphic(int id)
    {
        if (isTouched)
            return;

        switch(id)
        {
            case 1:
                Sprite = Apple;
                break;
            case 2:
                Sprite = Burger;
                break;
            case 3:
                Sprite = Study;
                break;
            case 4:
                Sprite = Coin;
                break;
            case 5:
                Sprite = Money;
                break;
            case 6:
                Sprite = Rocket;
                break;
            default:
                Sprite = Pacifier;
                break;
        }

        Pacifier.enabled = false;
        Burger.enabled = false;
        Study.enabled = false;
        Money.enabled = false;
        Apple.enabled = false;
        Coin.enabled = false;
        Rocket.enabled = false;

        Sprite.enabled = true;
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if (isTouched)
            return;

        Ball ball;
        if (collision.TryGetComponent<Ball>(out ball))
        {
            isTouched = true;
            UI.inst.TargetHit();

            ball.AddSideThrust();
            Audio.inst.PlayScoff();

            var explosion = ObjectPool.Inst.GetPooledObject("TargetExplosion");
            if (explosion != null)
            {
                explosion.transform.position = transform.position;
                explosion.GetComponent<VisualEffect>().Play();
                explosion.SetActive(true);
                StartCoroutine(DisableExplosionAfterTime(explosion));
            }

            gameObject.SetActive(false);
        }
    }

    private IEnumerator DisableExplosionAfterTime(GameObject explosion)
    {
        yield return new WaitForSeconds(3f);
        explosion.SetActive(false);
    }

}
