﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class SpawnSettings {

    public static int[,] d = new int[,] {
        { 1, 15, 5 },
        { 2, 15, 5 },
        { 3, 15, 5 },
        { 4, 15, 6 },
        { 5, 15, 7 },
        { 6, 15, 7 },
        { 7, 15, 8 },
        { 8, 15, 9 },
        { 9, 15, 9 },
        { 10, 15, 10 },
        { 11, 15, 10 },
        { 12, 15, 11 },
        { 13, 15, 11 },
    };



}


public class TargetSpawner : MonoBehaviour
{
    public GameObject Target;
    static public TargetSpawner inst;

    List<Target> targets = new List<Target>();

    GameObject childrenHolder;

    // Start is called before the first frame update
    void Start()
    {
        inst = this;
        Spawn();
    }

    // Update is called once per frame
    void Update()
    {

    }

    void Spawn()
    {
        childrenHolder = new GameObject("ChildrenHolder");
        childrenHolder.transform.parent = transform.parent;
        childrenHolder.transform.position = Vector3.zero;

        var rowCount = 0;
        var levelMax = SpawnSettings.d.GetLength(0);
        for (var level = 0; level < levelMax; level++)
        {
            var count = SpawnSettings.d[level, 1];
            var rows = SpawnSettings.d[level, 2];
            for (var i = 0; i < count; i++)
            {
                var x = UnityEngine.Random.Range(-6, 6) * 1f;
                var y = (UnityEngine.Random.Range(0, rows) + rowCount) * 1f;


                var copy = GameObject.Instantiate(Target);
                copy.transform.parent = childrenHolder.transform;
                copy.transform.position = new Vector3(x, y, 0f);
                var t = copy.GetComponent<Target>();
                t.SetGraphic(0);

                targets.Add(t);
            }
            rowCount += rows + 2;
        }
    }

    public void SetGraphics(int id)
    {
        foreach (var t in targets)
        {
            t.SetGraphic(id);
        }
    }

    public void Restart()
    {
        Despawn();
        Spawn();
    }

    private void Despawn()
    {
        targets.Clear();
        if (childrenHolder != null)
        { 
            Destroy(childrenHolder);
        }
    }
}
