﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class UI : MonoBehaviour
{
    public Text ScoreText;
    public static UI inst;

    public BallGFXParent BGP;

    public int Score = 0;
    public int Level = 0;

    public Text InstructionsAlive;
    public Text InstructionsDead;
    
    public Text YouWon;
    public Text YouWonReplay;
    public Animation WinAnimation;


    // Start is called before the first frame update
    void Start()
    {
        inst = this;
        SetInstructions(false);
    }

    // Update is called once per frame
    void Update()
    {
        ScoreText.text = string.Format("Score: {0}", Score);
    }

    public void TargetHit()
    {
        Score += 5;

        var newLevel = Mathf.FloorToInt(Score / 50);
        if (newLevel != Level)
        {
            Level = newLevel;
            UpdateLevelState();
        }
    }

    public void Restart()
    {
        Score = 0;
        Level = 0;
        SetInstructions(false);
    }

    public void UpdateLevelState()
    {
        UpdatePlayerState();
        UpdateTargetState();
    }

    private void UpdatePlayerState()
    {
        if (Level <= 1)
        {
            BGP.SwitchTo(0);
        }
        else if (Level <= 3)
        {
            BGP.SwitchTo(1);
        }
        else if (Level <= 6)
        {
            BGP.SwitchTo(2);
        }
        else if (Level <= 12)
        {
            BGP.SwitchTo(3);
        }
        else
        {
            BGP.SwitchTo(4);
        }
    }

    private void UpdateTargetState()
    {
        int id = 0;
        if (Level <= 0)
            id = 0;
        else if (Level == 1)
            id = 1;
        else if (Level == 2)
            id = 2;
        else if (Level == 3)
            id = 3;
        else if (Level == 4)
            id = 3;
        else if (Level == 5)
            id = 2;
        else if (Level == 6)
            id = 5;
        else if (Level == 7)
            id = 5;
        else if (Level == 8)
            id = 2;
        else if (Level == 9)
            id = 5;
        else if (Level == 10)
            id = 3;
        else if (Level == 11)
            id = 3;
        else if (Level == 12)
            id = 3;
        else if (Level == 12)
            id = 3;
        else
            id = 6;


        TargetSpawner.inst.SetGraphics(id);
    }

    internal void HasWon()
    {
        YouWon.enabled = true;
        YouWonReplay.enabled = true;
        WinAnimation.Play();
    }

    internal float GetHeightOfFire()
    {
        return Score / 30f + 1;
    }


    public void SetInstructions(bool isDead)
    {
        InstructionsAlive.enabled = !isDead;
        InstructionsDead.enabled = isDead;
        YouWon.enabled = false;
        YouWonReplay.enabled = false;
    }
}
